<?php
/**
**/
defined('_JEXEC') or die(':)');
$host = trim($params->get('host'));
$port = trim($params->get('port'));
$lozy = trim($params->get('lozy'));
$color_loader_map = trim($params->get('color_loader_map'));
$background_loader_wrapper = trim($params->get('background_loader_wrapper'));
$module_id = $module->id; // ID  module
$doc = JFactory::getDocument();
settype($getElementById, "string");
settype($loader, "string");
if($lozy==0) {
    $lozy = 100;
} else {
    $lozy = $lozy.'000';
    $getElementById = "document.getElementById('loader_wrapper_".$module_id."').style.visibility = 'hidden';";
    $doc->addStyleSheet('/modules/mod_maps2022/css/style.css');
    $loader = "<div style=\"background: $background_loader_wrapper\" id=\"loader_wrapper_$module_id\" class=\"loader_wrapper active \"><div style=\"color: $color_loader_map\" class=\"loader_map\">Loading...</div></div>";

}

if($params->get('apikey')) {
    $apikey = '?apikey='.$params->get('apikey').'&';
} else {
    $apikey = '?';
}

$script = "setTimeout(function(){
                    var elem = document.createElement('script');
                    elem.type = 'text/javascript';
                    elem.src = '//api-maps.yandex.ru/2.1/". $apikey ."load=package.full&lang=ru-RU&onload=getYaMap$module_id';
                    document.getElementsByTagName('body')[0].appendChild(elem);".$getElementById."                   
                }, ".$lozy.");";
$doc->addScriptDeclaration($script);

if ($params->get('centermap')) $centermap = $params->get('centermap');
if ($params->get('scope')) $scope = $params->get('scope');
if ($params->get('scrope_bool')==1) $zoomControl = "'zoomControl', "; else $zoomControl= '';
if ($params->get('bottom_bool')==1) $searchControl = "'searchControl', "; else $searchControl = '';
if ($params->get('typemap_bool')==1) $typeSelector = "'typeSelector', "; else $typeSelector = '';
if ($params->get('trafficControl')) $trafficControl = 'true'; else $trafficControl = 'false';
if ($params->get('scaling')==1)   $scaling = ''; else $scaling = "myMap.behaviors.disable('scrollZoom');";

if ($params->get('wi')) $wi = trim($params->get('wi'));
if ($params->get('he')) $he = trim($params->get('he'));
if ((strpos($wi, '%') === false) and (strpos($wi, 'px') === false)) $wi = $wi . "px";
if ((strpos($he, 'px') === false)) $he = $he . "px";
$he = str_replace('%','',$he);

if ($params->get('iconmap')) $iconmap = $params->get('iconmap');
if ($params->get('icon_wi')) $icon_wi = $params->get('icon_wi');
if ($params->get('icon_he')) $icon_he = $params->get('icon_he');
if ($params->get('zn1'))     $zn1 = $params->get('zn1');
if ($params->get('zn2'))     $zn2 = $params->get('zn2');
if ($params->get('items')) {
    foreach ($params->get('items') as $item) {
        if ($item->spb_point) $spb_point[] = $item->spb_point; else $spb_point[] = $iconmap;
        $spb_coordinates[] = ($item->spb_coordinates)??'';
        $spb_description[] = ($item->spb_description)??'';
        $spb_class[] = ($item->spb_class)??'';
    }

    foreach ($spb_point as $k => $Placemark) {
        $myPlacemark[$k] = "myPlacemark$k = new ymaps.Placemark([$spb_coordinates[$k]], {
                    balloonContent: '$spb_description[$k]'}, {
                    iconLayout: 'default#image',
                    iconImageHref: '/$spb_point[$k]',
                    iconImageSize: [$icon_wi, $icon_he],
                    iconImageOffset: [$zn1, $zn2]
                });";
        $addmyPlacemark[$k] = ".add(myPlacemark$k)";
    }
    $implodePlacemark = implode('', $myPlacemark);
    $implodeaddPlacemark = implode('', $addmyPlacemark);
}
$m = "<div id=\"map$module_id\" class=\"mod_map\" style=\"width:$wi; height:$he \">$loader</div>";
$m .= "<script>
           function getYaMap$module_id() {
                var myMap = new ymaps.Map(\"map$module_id\", {
                    center: [$centermap],
                    zoom: $scope,
                    controls: [$zoomControl $searchControl $typeSelector 'fullscreenControl']   }, 
                    {searchControlProvider: 'yandex#search' });
                    $implodePlacemark
                    var trafficControl = new ymaps.control.TrafficControl({ state: {
                    providerKey: 'traffic#actual',
                    trafficShown: $trafficControl
                }});
                myMap.controls.add(trafficControl);
                trafficControl.getProvider('traffic#actual').state.set('infoLayerShown', true);
                $scaling
                var myPlacemark = new ymaps.Placemark([$centermap], null, {                 
                    preset: 'islands#blueDotIcon',
                    draggable: true
                });

                myMap.geoObjects$implodeaddPlacemark;          

             }
                
		</script>";

require JModuleHelper::getLayoutPath('mod_maps2022', $params->get('layout', 'default'));




